<?php
/*
Plugin Name: Network Publisher
Plugin URI: http://wordpress.org/extend/plugins/network-publisher/
Description: Automatically posts your Articles to Social Networks - Twitter, Facebook Profile, Facebook Pages, LinkedIn, MySpace, Yammer, Yahoo, and Identi.ca
Version: 1.0.8
Author: LinksAlpha
Author URI: http://www.linksalpha.com
*/

/*
    Copyright (C) 2010 LinksAlpha.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

define('WIDGET_NAME', 'Network Publisher');
define('WIDGET_NAME_INTERNAL', 'networkpub');
define('WIDGET_PREFIX', 'networkpub');
define('NETWORKPUB', 'Automatically post your Articles to Social Networks - Facebook and Twitter');
define('ERROR_INTERNAL', 'internal error');
define('ERROR_INVALID_URL', 'invalid url');
define('ERROR_INVALID_KEY', 'invalid key');
if ( ! defined( 'WP_CONTENT_URL' ) )
      define( 'WP_CONTENT_URL', get_option( 'siteurl' ) . '/wp-content' );
if ( ! defined( 'WP_CONTENT_DIR' ) )
      define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
define('WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins' );

$networkpub_settings['api_key'] = array('label'=>'API Key:', 'type'=>'text', 'default'=>'');
$networkpub_settings['id'] = array('label'=>'id', 'type'=>'text', 'default'=>'');
$options = get_option(WIDGET_NAME_INTERNAL);

function networkpub_init() {
	wp_enqueue_script('jquery');
	wp_register_script('networkpubjs', WP_PLUGIN_URL .'/network-publisher/networkpub.js');
	wp_enqueue_script('networkpubjs');
	wp_register_style('networkpubcss', WP_PLUGIN_URL . '/network-publisher/networkpub.css');
	wp_enqueue_style('networkpubcss');
	add_action('admin_menu', 'networkpub_pages');	
	add_action('{$new_status}_{$post->post_type}', 'networkping');
	add_action('publish_post', 'networkping');
}

add_action('init', 'networkpub_init');
add_action('init', 'networkpub_remove');

function networkping($id) {
	if(!$id) {
		return FALSE;
	}
	$options = get_option(WIDGET_NAME_INTERNAL);
	$link = 'http://www.linksalpha.com/a/ping?id='.$options['id'];
	$response_full = networkpub_http($link);
	$response_code = $response_full[0];
	if ($response_code === 200) {
		return TRUE;
	}
	return FALSE;
}

function networkpub_pages() {
	if ( function_exists('add_submenu_page') ) {
		$page = add_submenu_page('plugins.php', WIDGET_NAME, WIDGET_NAME, 'manage_options', 'networkpub', 'networkpub_conf');
	}
}

function networkpub_conf() {
	global $networkpub_settings;
	
	if ( isset($_POST['submit']) ) {
		if ( function_exists('current_user_can') && !current_user_can('manage_options') ) {
			die(__('Cheatin&#8217; uh?'));
		}
		$field_name = sprintf('%s_%s', WIDGET_PREFIX, 'api_key');
		$value = strip_tags(stripslashes($_POST[$field_name]));
		if($value) {
			$networkadd = networkpub_add($value);	
		}
	}
	$options = get_option(WIDGET_NAME_INTERNAL);
	$html  = '<div id="networkpub_msg"></div>';
	$html .= '<div class="rts_header"><h2><img class="la_image" src="http://www.linksalpha.com/favicon.ico" />&nbsp;'.WIDGET_NAME.'</h2></div>';
	$html .= '<table style="width:100%;"><tr><td style="width:800px;"><table style="width:800px;"><tr><td style="padding-bottom:40px;">';
	$html .= '<div style="padding:0px 0px 10px 0px;">Network Publisher makes it easy and painless to Publish your Blog Posts to Social Networks. All you need to do is connect to your Social Networks at <a target="_blank" href="http://www.linksalpha.com/user/networks">LinksAlpha.com</a>, grab API Key for each enabled Network and enter it below. Once setup, your Blog posts content appears on the social networks as soon as you hit the Publish button.</div>';
	$html .= '<div style="padding:0px 0px 20px 0px;"><a href="http://www.linksalpha.com/user/networks" style="font-weight:bold;" target="_blank">Click Here</a> to get API Keys for your Social Networks. You can <a href="http://help.linksalpha.com/wordpress-plugin-network-publisher" target="_blank">read more about this process at LinksAlpha.com.</a></div>';
	$html .= '<div class="rts_header2"><big><strong>Setup</strong></big></div><div style="padding-left:0px;">';
	$html .= '<div class="la_content_box">';
	$html .= '<form action="" method="post" id="networkpubadd" name="networkpubadd" style="width:90%;">';
	$html .= '<fieldset class="rts_fieldset">';
	$html .= '<legend>Additional API Key</legend>';
	
	$curr_field = 'api_key';
	$field_name = sprintf('%s_%s', WIDGET_PREFIX, $curr_field);
	$html .= '<div><label for="'.$field_name.'">'.$networkpub_settings[$curr_field]['label'].'&nbsp;</label></div>';
	$html .= '<div style="padding-bottom:10px"><input style="width:400px;" class="widefat" id="'.$field_name.'" name="'.$field_name.'" type="text" /></div>';
	
	$html .= '</fieldset>';
	$html .= '<div style="padding-top:20px;"><input type="submit" name="submit" class="button-primary" value="Add API Key" /></div>';
	$html .= '<input type="hidden" value="'.WP_PLUGIN_URL.'" id="networkpub_plugin_url" /></form></div></td></tr><tr><td style="padding:0px 0px 0px 0px;vertical-align:top;">';
	$html .= '<div class="rts_header2"><big><strong>Currently Publishing</strong></big></div>';
	$html .= '<div class="la_content_box">'.networkpub_load().'</div>';
	$html .= '</div></td></tr></table></td><td style="width:250px;vertical-align:top;"><div class="rts_header2"><big><strong>More Plugins</strong></big></div><div class="la_content_box_3"><div style="padding:0px 0px 5px 0px"><a href="http://wordpress.org/extend/plugins/retweeters/">Retweeters</a></div><div><a href="http://wordpress.org/extend/plugins/buzz-roll/">Buzz Roll</a></div></div></td></tr></table>';
	echo $html;
}

function more_plugins() {
	$html = '<div><big><strong>Setup</strong></big></div>';
	echo $html;
}

function networkpub_add($api_key) {
	if (!$api_key) {
		echo '<div class="msg_error">Error occured while processing your request. Error Code 100</div>';
		return FALSE;
	}
	$url = get_bloginfo('url');
	$desc = get_bloginfo('description');
	if (!$url) {
		echo '<div class="msg_error">Error occured while processing your request. Error Code 200</div>';
		return FALSE;
	}
	$link = 'http://www.linksalpha.com/a/networkpubadd?url='.urlencode($url).'&key='.$api_key;
	$response_full = networkpub_http($link);
	$response_code = $response_full[0];
	if ($response_code != 200) {
		echo '<div class="msg_error">Error occured while adding the API Key. As a workaround, you can configure the publishing at the following link: <a href="http://www.linksalpha.com/user/publish">LinksAlpha Publisher</a> </div>';
		return FALSE;
	}
	$response = networkpub_json_decode($response_full[1]);
	if ($response->errorCode > 0) {
		if ($response->errorMessage == ERROR_INVALID_KEY) {
			echo '<div class="msg_error">Error occured while processing your request. Please input valid API Key. Error Code 400</div>';
		} else {
			echo '<div class="msg_error">Error occured while processing your request. Error Code 500</div>';	
		}
		return FALSE;
	}
	$options = get_option(WIDGET_NAME_INTERNAL);
	if(empty($options['api_key'])) {
		$options['api_key'] = $api_key;	
	} else {
		$options_array = explode(',', $options['api_key']);
		if(!in_array($api_key, $options_array)) {
			$options['api_key'] = $options['api_key'].','.$api_key;	
		}
	}
	$options['id'] = $response->results->id; 
	update_option(WIDGET_NAME_INTERNAL, $options);
	echo '<div class="msg_success">API Key has been added successfully</div>';
	return TRUE;	
}

function networkpub_load() {
	$options = get_option(WIDGET_NAME_INTERNAL);
	if (empty($options['api_key'])) {
		$html = '<div class="msg_error">You have not added any API Key</div>';
		return $html;
	}
	$link = 'http://www.linksalpha.com/a/networkpubget';
	$body = array('key'=>$options['api_key']);
	$response_full = networkpub_http_post($link, $body);
	$response_code = $response_full[0];
	if ($response_code != 200) {
		$html = '<div class="msg_error">Error occured while trying to load the API Keys. Please try again later.</div>';
		return $html;
	}
	$response = networkpub_json_decode($response_full[1]);
	if($response->errorCode > 0) {
		$html = '<div class="msg_error">Error occured while trying to load the API Keys. Please try again later.</div>';
		return $html;
	}
	$html = '<div style="padding-bottom:10px;">You are currently Publishing your Blog to '.count($response->results).' Social Networks</div>';
	$html .= '<table class="networkpub_added"><tr><th>API Key</th><th>Network</th><th>Option</th></tr>';
	if (count($response->results)) {
		foreach($response->results as $row) {
			$html .= '<tr id="r_key_'.$row->api_key.'">';
			switch($row->type) {
				case 'twitter':
					$html  .= '<td>'.$row->api_key.'</td><td>Twitter Account - <a target="_blank" href="http://twitter.com/'.$row->short_name.'">'.$row->name.'</a></td>';
					break;
				case 'fb_page':
					$html  .= '<td>'.$row->api_key.'</td><td>Facebook Page - <a target="_blank" href="'.$row->page_url.'">'.$row->name.'</a></td>';
					break;
				case 'fb_wall':
					$html  .= '<td>'.$row->api_key.'</td><td><a target="_blank" href="http://www.facebook.com/profile.php?id='.$row->id.'">'.$row->name.'</a></td>';
					break;	
				case 'myspace':
					$html  .= '<td>'.$row->api_key.'</td><td>MySpace Account - <a target="_blank" href="'.$row->page_url.'">'.$row->name.'</a></td>';
					break;	
				case 'linkedin':
					$html  .= '<td>'.$row->api_key.'</td><td>LinkedIn Account - <a target="_blank" href="'.$row->page_url.'">'.$row->name.'</a></td>';
					break;
				case 'yammer':
					$html  .= '<td>'.$row->api_key.'</td><td>Yammer Account - <a target="_blank" href="'.$row->page_url.'">'.$row->name.'</a></td>';
					break;
				case 'yahoo':
					$html  .= '<td>'.$row->api_key.'</td><td>Yahoo Account - <a target="_blank" href="http://profiles.yahoo.com/u/'.$row->id.'">'.$row->name.'</a></td>';
					break;
				case 'identica':
					$html  .= '<td>'.$row->api_key.'</td><td>Identi.ca Account - <a target="_blank" href="http://identi.ca/'.$row->short_name.'">'.$row->short_name.'</a></td>';
					break;	
			}
			$html .= '<td><a href="#" id="key_'.$row->api_key.'" class="networkpubre">Remove</a></td></tr>';
		}
	} else {
		$html .= '<tr><td colspan="3" style="text-align:center;padding:5px 0px 5px 0px;">No API Keys have been added</td></tr>';
	}
	$html .= '</table>';
	return $html;
}

function networkpub_remove() {
	$options = get_option(WIDGET_NAME_INTERNAL);
	if (!empty($_POST['key'])) {
		$key_full = $_POST['key'];
		$key_only = substr($key_full, 4);
		$link = 'http://www.linksalpha.com/a/networkpubremove?id='.$options['id'].'&key='.$key_only;
		$response_full = networkpub_http($link);
		$response_code = $response_full[0];
		if ($response_code != 200) {
			echo 500;
			return;
		}
		$api_key = $options['api_key'];
		$api_key_array = explode(',', $api_key);
		$loc = array_search($key_only, $api_key_array);
		if($loc !== FALSE) {
			unset($api_key_array[$loc]);
		}
		$api_key = implode(",", $api_key_array);
		$options['api_key'] = $api_key;
		update_option(WIDGET_NAME_INTERNAL, $options);	
		echo $key_full;
		return;
	}
}

function networkpub_json_decode($str) {
	if (function_exists("json_decode")) {
	    return json_decode($str);
	} else {
		if (!class_exists('Services_JSON')) {
			require_once("JSON.php");
		}
	    $json = new Services_JSON();
	    return $json->decode($str);
	}
}

function networkpub_http($link) {
	if (!$link) {
		return array(500, 'Invalid Link');
	}
	require_once(ABSPATH.WPINC.'/class-snoopy.php');
	$snoop = new Snoopy;
	$snoop->agent = WIDGET_NAME.' - '.get_bloginfo('url');
	if($snoop->fetchtext($link)){
		if (strpos($snoop->response_code, '200')) {
			$response = $snoop->results;
			return array(200, $response);
		} 
	}
	if( !class_exists( 'WP_Http' ) ) {
		include_once( ABSPATH . WPINC. '/class-http.php' );	
	}
	if (!class_exists('WP_Http')) {
		return array(500, $snoop->response_code);	
	}
	$request = new WP_Http;
	$headers = array( 'Agent' => WIDGET_NAME.' - '.get_bloginfo('url') );
	$response_full = $request->request( $link );
	$response_code = $response_full['response']['code'];
	if ($response_code === 200) {
		$response = $response_full['body'];
		return array($response_code, $response);
	}
	$response_msg = $response_full['response']['message'];
	return array($response_code, $response_msg);
}

function networkpub_http_post($link, $body) {
	if (!$link) {
		return array(500, 'Invalid Link');
	}	
	require_once(ABSPATH.WPINC.'/class-snoopy.php');
	$snoop = new Snoopy;
	$snoop->agent = WIDGET_NAME.' - '.get_bloginfo('url');
	if($snoop->submit($link, $body)){
		if (strpos($snoop->response_code, '200')) {
			$response = $snoop->results;
			return array(200, $response);
		} 
	}	
	if( !class_exists( 'WP_Http' ) ) {
		include_once( ABSPATH . WPINC. '/class-http.php' );	
	}	
    if (!class_exists('WP_Http')) {
		return array(500, $snoop->response_code);	
	}	
	$request = new WP_Http;
	$headers = array( 'Agent' => WIDGET_NAME.' - '.get_bloginfo('url') );
	$response_full = $request->request( $link, array( 'method' => 'POST', 'body' => $body, 'headers'=>$headers) );

	if(isset($response_full->errors)) {			
		return array(500, 'Unknown Error');				
	}	

	$response_code = $response_full['response']['code'];
	if ($response_code === 200) {
		$response = $response_full['body'];
		return array($response_code, $response);
	}
	$response_msg = $response_full['response']['message'];
	return array($response_code, $response_msg);
}


?>
